using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;


namespace Model
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl gridGroupingControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//

		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridGroupingControl1 = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridGroupingControl1
			// 
			this.gridGroupingControl1.BackColor = System.Drawing.SystemColors.Window;
			this.gridGroupingControl1.Location = new System.Drawing.Point(8, 8);
			this.gridGroupingControl1.Name = "gridGroupingControl1";
			this.gridGroupingControl1.Size = new System.Drawing.Size(280, 216);
			this.gridGroupingControl1.TabIndex = 0;
			this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = System.Windows.Forms.SelectionMode.MultiExtended;
			this.gridGroupingControl1.Text = "gridGroupingControl1";
			this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridGroupingControl1.VersionInfo = "3.201.1.0";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.Add(this.gridGroupingControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridGroupingControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			DataTable dt = new DataTable("MyTable");
			dt.Columns.Add("Col1",System.Type.GetType("System.String"));
			dt.Columns.Add("Col2",System.Type.GetType("System.Int32"));
			dt.Columns.Add("Col3",System.Type.GetType("System.String"));

			DataRow dr ;
			for(int i = 1;i < 10;i++)
			{
				dr = dt.NewRow();
				dr[0] = "Col1Row"+i.ToString();
				if(i % 2 == 0)
					dr[1] = 3;
				else
					dr[1] = 5;
				dr[2] = "Col3Row"+i;
				dt.Rows.Add(dr);
			}

			this.gridGroupingControl1.DataSource = dt;

			Syncfusion.Windows.Forms.Grid.GridModel gm = new GridModel();;
			GridTableFilterBarCellModel1 g = new GridTableFilterBarCellModel1(gm);
			this.gridGroupingControl1.TableControl.Model.CellModels.Add("FilterBarCell1",g);

			this.gridGroupingControl1.TopLevelGroupOptions.ShowFilterBar = true;
			this.gridGroupingControl1.TableDescriptor.Appearance.FilterBarCell.CellType = "FilterBarCell1";
			this.gridGroupingControl1.TableDescriptor.Columns["Col1"].AllowFilter = true;
		}


		public class GridTableFilterBarCellModel1: GridTableFilterBarCellModel
		{
			public GridTableFilterBarCellModel1(Syncfusion.Windows.Forms.Grid.GridModel gm):base(gm)
			{
			}

			public override void FillWithChoices(ListBox listBox, GridStyleInfo style, out bool exclusive)
			{
				exclusive = true;
				GridTableCellStyleInfo tableStyleInfo = (GridTableCellStyleInfo) style;

				object[] items = (object[]) GetFilterBarChoices(tableStyleInfo.TableCellIdentity);

				listBox.Items.Clear();

				if (items != null)
				{
					listBox.Items.Add(SelectAllText);

					foreach (object item in items)
					{
						if (item is DBNull)
							listBox.Items.Add(SelectEmptyText);

						else if (item != null)
							listBox.Items.Add(style.GetFormattedText(item));
					}
				}
			}

			public void Select_WithoutCustom(GridTableCellStyleInfoIdentity tableCellIdentity, int index)
			{
				if (index >= 0)
				{
					if (index == 0)
					{
						ResetFilterBar(tableCellIdentity);
					}
					else if (index == 1)
					{
						SelectItem(tableCellIdentity, 0);						
					}
					else
					{
						SelectItem(tableCellIdentity, index-1);
					}
				}
			}

			public override GridCellRendererBase CreateRenderer(GridControlBase control)
			{
				return new Cellrenderer(control, this); 
			}
		}


		}
		public class Cellrenderer : GridTableFilterBarCellRenderer
		{
			public  Cellrenderer(GridControlBase grid, GridCellModelBase cellModel): base(grid , cellModel)
			{
			}
		
			public new Model.Form1.GridTableFilterBarCellModel1 Model
			{
				get
				{
					return (Model.Form1.GridTableFilterBarCellModel1) base.Model;
				}
			}

			protected override void ListBoxMouseUp(object sender, MouseEventArgs e)
			{
				CurrentCell.CloseDropDown(PopupCloseType.Done);
				GridTableCellStyleInfo tableStyleInfo = (GridTableCellStyleInfo) this.StyleInfo;
				GridTableCellStyleInfoIdentity tableCellIdentity = tableStyleInfo.TableCellIdentity;
			
				Model.Select_WithoutCustom(tableCellIdentity, this.ListBoxPart.SelectedIndex);
				SetTextBoxText(GetFilterBarText(StyleInfo), false);// don't call base class - ignore.			
			}
		}		
	}